/*
 * Copyright 1999, Be Incorporated. All Rights Reserved.
 * This file may be used under the terms of the Be Sample Code License.
 *
 */
#ifndef _TEST_WINDOW_H
#define _TEST_WINDOW_H


#include <Window.h>
#include <Bitmap.h>
#include <View.h>

class TestView : public BView {
	public:
							TestView(BRect frame, const char *name); 
		virtual				~TestView();

		virtual	void		Draw(BRect updateRect);				
		void 				SetBitmap(BBitmap *bmp);
		void				SetZoom(float z);		
		float				Zoom(void);
		
		void 				RescaleBitmap(void);
		
	private:
		BBitmap			*fBitmap;
		BBitmap			*fBitmapSized;
		float 			zoom;
};


class TestWindow : public BWindow {
	public:
						TestWindow(BRect rect, const char* name);
		virtual			~TestWindow();

		virtual	bool	QuitRequested();
		virtual void 	MessageReceived(BMessage *message);
		void 			SetBitmap(BBitmap *bmp);

	private:		
		void			_InitWindow();
		TestView	 	*fView;
};

#endif

